view hgeditor @ 17109:7ba2b9435da9

test-hgweb-diffs: partially adapt for Windows Since chmod isn't supported on Windows (or vfat), I'm importing a here-doc instead (<<EOF ..). Option --bypass on import of the here-doc is required on Windows (or vfat) to bypass the working directory (see hg help import). Not using --bypass would lose the mode changing bits. I've had to insert a --bypass on the preexisting import call futher down in the test, because importing a patch with --exact and mode changes will fail on Windows (and vfat). As the point of this test is not to test commit, I'm using the import procedure for all platforms unconditionally, that is, I'm intentionally not keeping the original sequence of hg and chmod calls for platforms that support exec either, which saves us having to insert an #if exec ... #else ... #endif.
author Adrian Buehlmann <adrian@cadifra.com>
date Wed, 04 Jul 2012 12:43:13 +0200
parents 2b440bb8a66b
children 1aee2ab0f902
line wrap: on
line source

#!/bin/sh
#
# This is an example of using HGEDITOR to create of diff to review the
# changes while commiting.

# If you want to pass your favourite editor some other parameters
# only for Mercurial, modify this:
case "${EDITOR}" in
    "")
        EDITOR="vi"
        ;;
    emacs)
        EDITOR="$EDITOR -nw"
        ;;
    gvim|vim)
        EDITOR="$EDITOR -f -o"
        ;;
esac


HGTMP=""
cleanup_exit() {
    rm -rf "$HGTMP"
}

# Remove temporary files even if we get interrupted
trap "cleanup_exit" 0 # normal exit
trap "exit 255" HUP INT QUIT ABRT TERM

HGTMP=$(mktemp -d ${TMPDIR-/tmp}/hgeditor.XXXXXX)
[ x$HGTMP != x -a -d $HGTMP ] || {
  echo "Could not create temporary directory! Exiting." 1>&2
  exit 1
}

(
    grep '^HG: changed' "$1" | cut -b 13- | while read changed; do
        "$HG" diff "$changed" >> "$HGTMP/diff"
    done
)

cat "$1" > "$HGTMP/msg"

MD5=$(which md5sum 2>/dev/null) || \
    MD5=$(which md5 2>/dev/null)
[ -x "${MD5}" ] && CHECKSUM=`${MD5} "$HGTMP/msg"`
if [ -s "$HGTMP/diff" ]; then
    $EDITOR "$HGTMP/msg" "$HGTMP/diff" || exit $?
else
    $EDITOR "$HGTMP/msg" || exit $?
fi
[ -x "${MD5}" ] && (echo "$CHECKSUM" | ${MD5} -c >/dev/null 2>&1 && exit 13)

mv "$HGTMP/msg" "$1"

exit $?